
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>Routes management &#8212; pyroute2 0.5.14 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="_static/custom.css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Database" href="ndb_schema.html" />
    <link rel="prev" title="IP addresses management" href="ndb_addresses.html" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-121787797-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-121787797-2');
</script>
 

  </head><body>

    <div class="related" role="navigation" aria-label="related navigation">
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="ndb_schema.html" title="Database"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ndb_addresses.html" title="IP addresses management"
             accesskey="P">previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="ndb.html" accesskey="U">NDB module</a> &#187;</li> 
      </ul>
        </div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-pyroute2.ndb.objects.route">
<span id="routes-management"></span><span id="ndbroutes"></span><h1>Routes management<a class="headerlink" href="#module-pyroute2.ndb.objects.route" title="Permalink to this headline">¶</a></h1>
<div class="section" id="simple-routes">
<h2>Simple routes<a class="headerlink" href="#simple-routes" title="Permalink to this headline">¶</a></h2>
<p>Ordinary routes management is really simple:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">(</span><span class="n">ndb</span>            <span class="c1"># create a route</span>
 <span class="o">.</span><span class="n">routes</span>
 <span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">dst</span><span class="o">=</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">,</span> <span class="n">gateway</span><span class="o">=</span><span class="s1">&#39;192.168.122.1&#39;</span><span class="p">)</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>

<span class="p">(</span><span class="n">ndb</span>            <span class="c1"># retrieve a route and change it</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">]</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;gateway&#39;</span><span class="p">,</span> <span class="s1">&#39;192.168.122.10&#39;</span><span class="p">)</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;priority&#39;</span><span class="p">,</span> <span class="mi">500</span><span class="p">)</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>

<span class="p">(</span><span class="n">ndb</span>            <span class="c1"># remove a route</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">]</span>
 <span class="o">.</span><span class="n">remove</span><span class="p">()</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="section" id="multiple-routing-tables">
<h2>Multiple routing tables<a class="headerlink" href="#multiple-routing-tables" title="Permalink to this headline">¶</a></h2>
<p>But Linux systems have more than one routing table:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="nb">set</span><span class="p">((</span><span class="n">x</span><span class="o">.</span><span class="n">table</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">ndb</span><span class="o">.</span><span class="n">routes</span><span class="o">.</span><span class="n">summary</span><span class="p">()))</span>
<span class="go">{101, 254, 255, 5001, 5002}</span>
</pre></div>
</div>
<p>The main routing table is 254. All the routes people mostly work with are
in that table. To address routes in other routing tables, you can use dict
specs:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">routes</span>
 <span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">dst</span><span class="o">=</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">,</span> <span class="n">gateway</span><span class="o">=</span><span class="s1">&#39;192.168.122.1&#39;</span><span class="p">,</span> <span class="n">table</span><span class="o">=</span><span class="mi">101</span><span class="p">)</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>

<span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[{</span><span class="s1">&#39;table&#39;</span><span class="p">:</span> <span class="mi">101</span><span class="p">,</span> <span class="s1">&#39;dst&#39;</span><span class="p">:</span> <span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">}]</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;gateway&#39;</span><span class="p">,</span> <span class="s1">&#39;192.168.122.10&#39;</span><span class="p">)</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;priority&#39;</span><span class="p">,</span> <span class="mi">500</span><span class="p">)</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>

<span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[{</span><span class="s1">&#39;table&#39;</span><span class="p">:</span> <span class="mi">101</span><span class="p">,</span> <span class="s1">&#39;dst&#39;</span><span class="p">:</span> <span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">}]</span>
 <span class="o">.</span><span class="n">remove</span><span class="p">()</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="section" id="route-metrics">
<h2>Route metrics<a class="headerlink" href="#route-metrics" title="Permalink to this headline">¶</a></h2>
<p><cite>route[‘metrics’]</cite> attribute provides a dictionary-like object that
reflects route metrics like hop limit, mtu etc:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># set up all metrics from a dictionary</span>
<span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">]</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;metrics&#39;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;mtu&#39;</span><span class="p">:</span> <span class="mi">1500</span><span class="p">,</span> <span class="s1">&#39;hoplimit&#39;</span><span class="p">:</span> <span class="mi">20</span><span class="p">})</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>

<span class="c1"># fix individual metrics</span>
<span class="p">(</span><span class="n">ndb</span>
 <span class="o">.</span><span class="n">routes</span><span class="p">[</span><span class="s1">&#39;10.0.0.0/24&#39;</span><span class="p">][</span><span class="s1">&#39;metrics&#39;</span><span class="p">]</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;mtu&#39;</span><span class="p">,</span> <span class="mi">1500</span><span class="p">)</span>
 <span class="o">.</span><span class="n">set</span><span class="p">(</span><span class="s1">&#39;hoplimit&#39;</span><span class="p">,</span> <span class="mi">20</span><span class="p">)</span>
 <span class="o">.</span><span class="n">commit</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="section" id="mpls-routes">
<h2>MPLS routes<a class="headerlink" href="#mpls-routes" title="Permalink to this headline">¶</a></h2>
<p>See here: <a class="reference internal" href="mpls.html#mpls"><span class="std std-ref">MPLS howto</span></a></p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Routes management</a><ul>
<li><a class="reference internal" href="#simple-routes">Simple routes</a></li>
<li><a class="reference internal" href="#multiple-routing-tables">Multiple routing tables</a></li>
<li><a class="reference internal" href="#route-metrics">Route metrics</a></li>
<li><a class="reference internal" href="#mpls-routes">MPLS routes</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ndb_addresses.html"
                        title="previous chapter">IP addresses management</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="ndb_schema.html"
                        title="next chapter">Database</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/ndb_routes.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="ndb_schema.html" title="Database"
             >next</a> |</li>
        <li class="right" >
          <a href="ndb_addresses.html" title="IP addresses management"
             >previous</a> |</li>
        <li class="nav-item"><a href="http://pyroute2.org">Project home</a> &#187;</li>
        <li class="nav-item nav-item-0"><a href="index.html">pyroute2 0.5.14 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="ndb.html" >NDB module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, Peter V. Saveliev.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.1.2.
    </div>
  </body>
</html>